//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Brown
#property indicator_width1 4
#property indicator_width2 4
#property indicator_minimum 0
#property indicator_maximum 1


//
//
//
//
//

extern int Length  = 10;   //    inverse of driving coefficient
extern int Damping =  5;   //    smoothing percent
extern int MaxGap  = 30;   //    maximum week gap ignored (pips)
extern int Shift   =  0;
extern int Price   = PRICE_MEDIAN;

double mma[];
double BufferA[];
double BufferB[];
double trend[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);

  SetIndexBuffer(0,BufferA); SetIndexShift(0,Shift);
  SetIndexBuffer(1,BufferB); SetIndexShift(1,Shift);
  SetIndexStyle(0,DRAW_HISTOGRAM);   SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,mma); SetIndexShift(2,Shift);

  SetIndexBuffer(3,trend);
   IndicatorShortName ("Moris MMA ("+Length+", "+Damping+", "+MaxGap+", "+Shift+")");    
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
   double GapLimit = MaxGap*Point; if (Digits==3 || Digits==5) GapLimit *= 10.0;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         double y1 = work[r-1][_y1];
         double y2 = work[r-1][_y2];
         
            if ((High[i]<Low[i+1]) || (Low[i]>High[i+1]))
            {
               double gap = work[r][_price]-work[r-1][_price];
   	      		if (MathAbs(gap)>GapLimit)
                  {
                     y1 = mma[i+1]+gap;
                     y2 = mma[i+2]+gap;
                  }
            }            
            
         double noise  = MathMax(High[i]-Low[i],0.000001);
         double err    = (work[r][_price]-2.0*y1+y2)/noise; 
         double drv    = MathMax(MathMin((1.0/Length)*err*err+(1.0/Length)*MathAbs(err),0.5),0.0);
         double dmp    = MathMax(MathMin((1.0/Length)*MathAbs(y1-y2)/noise + Damping/100.0,1.0),0.0);
         
         //
         //
         //
         //
         //
         
      mma[i]       = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
      work[r][_y1] = mma[i];
      work[r][_y2] = y1;

        trend[i]=trend[i+1];      
         BufferA[i] = EMPTY_VALUE;
         BufferB[i] = EMPTY_VALUE;
            if (mma[i] > mma[i+1]) trend[i] = 1;
            if (mma[i] < mma[i+1]) trend[i] =-1;
            if (trend[i]== 1) BufferA[i] = 1;
            if (trend[i]==-1) BufferB[i] = 1;


   }   
   return(0);           
}